/*******************************************************************************
*                   Copyright (c) 1991-1994 Gemplus Development
*
* Name        : GemMac.h
*
* Description : General macro definitions for GEMPLUS programs
*
* Release     : 4.00
*
* Last Modif  : 22/08/94: V4.00
* Date        : 06/07/94: V4.00
*
********************************************************************************
*
* Warning     :
*
* Remark      :
*
*******************************************************************************/


/*------------------------------------------------------------------------------
Name definition:
   _GEMMAC_H is used to avoid multiple inclusion.
------------------------------------------------------------------------------*/
#ifndef _GEMMAC_H
#define _GEMMAC_H


/*------------------------------------------------------------------------------
General C macros.
------------------------------------------------------------------------------*/
#ifndef LOWORD
   #define LOWORD(l)   ((WORD)(l))
   #define HIWORD(l)   ((WORD)(((WORD32)(l)) >> 16))
   #define LOBYTE(w)   ((BYTE)(w))
   #define HIBYTE(w)   ((BYTE)(((WORD16)(w)) >> 8))
#endif

#ifndef MK_FP
   #define MK_FP(seg,ofs) ((void far *)((((WORD32)(seg))<<16)|(ofs)))
#endif
#define PEEKW(seg,ofs) *((unsigned short far *)MK_FP ((seg),(ofs)))


/*------------------------------------------------------------------------------
Macros used to read a port address under DOS environment.
------------------------------------------------------------------------------*/
#define ComPort(i) PEEKW(0x40 ,2 * ((i) - 1))
#define LptPort(i) PEEKW(0x40,8 + 2*((i) - 1))

#endif 
